#include "servo.h"
#include "app_pwm.h"

APP_PWM_INSTANCE(PWM2, 2);

#define PIN_SERVO 27

static inline int SATURATE_DUTY(int duty) {
	if (duty < 0)
		duty = 0;
	if (duty > 90)
		duty = 90;
	return duty;
}

static void pwm_ready_callback(uint32_t pwm_id)
{
	// dummy function
}

void servo_init() {
	nrfx_err_t err;
	
	app_pwm_config_t pwm2_cfg = APP_PWM_DEFAULT_CONFIG_1CH(10000L, PIN_SERVO);
	pwm2_cfg.pin_polarity[0] = APP_PWM_POLARITY_ACTIVE_HIGH;
	
	err = app_pwm_init(&PWM2, &pwm2_cfg, pwm_ready_callback);
	APP_ERROR_CHECK(err);
	
	app_pwm_enable(&PWM2);
}

void servo_position(int duty) {
	nrfx_err_t err;
	
	while (app_pwm_channel_duty_set(&PWM2, 0, duty) == NRF_ERROR_BUSY);
}